C GETHOSTBYNAME.FOR
C
c Date:     Thu, 11 Jul 91 18:50:01 PDT
c From:     rankin@EQL.Caltech.Edu (Pat Rankin)
c Message-Id: <910711184952.24604b63@EQL.Caltech.Edu>
c cmu-gethostbyname.for -- emulates gethostbyname() for CMU/TEK TCP-IP
c
c Bruce Miller/bm17+@anywhere/910531
c
c translated from C into FORTRAN -- 11-jul-91 [pr]
c

c function return value is a pointer (4 bytes)
      integer *4 function gethostbyname( name )

	implicit none
	include '($iodef)/nolist'
c     input argument
	byte            name(*)

*
* Standard gethostbyname() hostentry
*
	structure /hostent/
	    integer*4   h_name          ! official name (ptr)
	    integer*4   h_aliases       ! alias list (ptr to ptrs)
	    integer     h_addrtype      ! host address type
	    integer     h_length        ! length of address
	    integer*4   h_addr_list     ! list of addresses (ptr to ptrs)
c       #define h_addr  h_addr_list[0]  ! address, for compat
	    integer*4   h_cputype       ! cpu type (ptr)
	    integer*4   h_opsys         ! operating system (ptr)
	    integer*4   h_protos        ! protocols (ptr to ptrs)
	    integer*4   h_addresses     ! sockaddr form (ptr to struct)
	end structure !hostent

*
* Constants and structures from CMU/TEK TCP-IP
*
	parameter       U$GH_NAMADR = 1

	parameter       MAX_HADDRS = 20
	parameter       MAX_HNAME = 128

	structure /GTHST_NMLOOK_BLOCK/
	    integer*4 GHA$NL_ADRCNT             ! Count of addresses
	    integer*4 GHA$NL_ADRLST(MAX_HADDRS) ! Address list
	    integer*4 GHA$NL_NAMLEN             ! Official name length
	    byte      GHA$NL_NAMSTR(MAX_HNAME)  ! Official name string
	end structure !GTHST_NMLOOK_BLOCK
	parameter       BUFFER_SIZE = (4 + MAX_HADDRS*4 + 4 + MAX_HNAME)

c     static variables
	record /GTHST_NMLOOK_BLOCK/ buffer
	record /hostent/        uglyness
	integer*4               hostaddr
c     local variables
	integer*2               IOSB(4)
	integer*4               RC
	integer*2               chan
c     functions
	integer*4               SYS$ASSIGN, SYS$QIOW, SYS$DASSGN

*
* Returns a pointer to a hostent, or null in case of error.
*
	gethostbyname = 0       !assume NULL

	RC = SYS$ASSIGN('INET$DEVICE', chan,,)
	if (.not. RC) return

	RC = SYS$QIOW(, %VAL(chan), %VAL(IO$_SKIPFILE), IOSB,,,
     &                buffer, BUFFER_SIZE, %VAL(U$GH_NAMADR), name,,)
	if (.not. RC) return
	if (.not.IOSB(1)) return

	hostaddr = %LOC(buffer.GHA$NL_ADRLST(0))
	uglyness.h_addr_list = hostaddr

	RC = SYS$DASSGN(%VAL(chan))
	if (.not. RC) return

	gethostbyname = %LOC(uglyness)
	return
      end !of gethostbyname
